VTK: vtkExecutionTimer Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
vtkExecutionTimer Class Reference

Time filter execution. More...

`#include <vtkExecutionTimer.h>`

Inheritance diagram for vtkExecutionTimer:
[legend]
Collaboration diagram for vtkExecutionTimer:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkExecutionTimer * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetFilter (vtkAlgorithm *filter)
| Set/get the filter to be monitored. More...
virtual vtkAlgorithm * | GetFilter ()
| Set/get the filter to be monitored. More...
virtual double | GetElapsedCPUTime ()
| Get the total CPU time (in seconds) that elapsed between StartEvent and EndEvent. More...
virtual double | GetElapsedWallClockTime ()
| Get the total wall clock time (in seconds) that elapsed between StartEvent and EndEvent. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkExecutionTimer * | SafeDownCast (vtkObjectBase *o)
static vtkExecutionTimer * | New ()
| Construct a new timer with no attached filter. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkExecutionTimer ()
| ~vtkExecutionTimer () override
virtual void | TimerFinished ()
| This is where you can do anything you want with the progress event. More...
void | StartTimer ()
| Convenience functions – StartTimer clears out the elapsed times and records start times; StopTimer records end times and computes the elapsed time. More...
void | StopTimer ()
| Convenience functions – StartTimer clears out the elapsed times and records start times; StopTimer records end times and computes the elapsed time. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | EventRelay (vtkObject *caller, unsigned long eventId, void *clientData, void *callData)
| This is the callback that VTK will invoke when it sees StartEvent and EndEvent. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
vtkCallbackCommand * | Callback
vtkAlgorithm * | Filter
double | CPUStartTime
double | CPUEndTime
double | WallClockStartTime
double | WallClockEndTime
double | ElapsedCPUTime
double | ElapsedWallClockTime
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Time filter execution.

This object monitors a single filter for StartEvent and EndEvent. Each time it hears StartEvent it records the time. Each time it hears EndEvent it measures the elapsed time (both CPU and wall-clock) since the most recent StartEvent. Internally we use vtkTimerLog for measurements.

By default we simply store the elapsed time. You are welcome to subclass and override TimerFinished() to do anything you want.

Tests:
  vtkExecutionTimer (Tests)

Definition at line 33 of file vtkExecutionTimer.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkExecutionTimer::Superclass

Definition at line 36 of file vtkExecutionTimer.h.

## Constructor & Destructor Documentation

## ◆ vtkExecutionTimer()

vtkExecutionTimer::vtkExecutionTimer | ( |  | ) |
| protected

## ◆ ~vtkExecutionTimer()

vtkExecutionTimer::~vtkExecutionTimer | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkExecutionTimer::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkExecutionTimer::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkExecutionTimer* vtkExecutionTimer::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkExecutionTimer::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkExecutionTimer* vtkExecutionTimer::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkExecutionTimer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ New()

static vtkExecutionTimer* vtkExecutionTimer::New | ( |  | ) |
| static

Construct a new timer with no attached filter.

Use SetFilter() to specify the vtkAlgorithm whose execution you want to time.

## ◆ SetFilter()

void vtkExecutionTimer::SetFilter | ( | vtkAlgorithm * | filter | ) |

Set/get the filter to be monitored.

The only real constraint here is that the vtkExecutive associated with the filter must fire StartEvent and EndEvent before and after the filter is executed. All VTK executives should do this.

## ◆ GetFilter()

virtual vtkAlgorithm* vtkExecutionTimer::GetFilter | ( |  | ) |
| virtual

Set/get the filter to be monitored.

The only real constraint here is that the vtkExecutive associated with the filter must fire StartEvent and EndEvent before and after the filter is executed. All VTK executives should do this.

## ◆ GetElapsedCPUTime()

virtual double vtkExecutionTimer::GetElapsedCPUTime | ( |  | ) |
| virtual

Get the total CPU time (in seconds) that elapsed between StartEvent and EndEvent.

This is undefined before the filter has finished executing.

## ◆ GetElapsedWallClockTime()

virtual double vtkExecutionTimer::GetElapsedWallClockTime | ( |  | ) |
| virtual

Get the total wall clock time (in seconds) that elapsed between StartEvent and EndEvent.

This is undefined before the filter has finished executing.

## ◆ StartTimer()

void vtkExecutionTimer::StartTimer | ( |  | ) |
| protected

Convenience functions – StartTimer clears out the elapsed times and records start times; StopTimer records end times and computes the elapsed time.

## ◆ StopTimer()

void vtkExecutionTimer::StopTimer | ( |  | ) |
| protected

Convenience functions – StartTimer clears out the elapsed times and records start times; StopTimer records end times and computes the elapsed time.

## ◆ TimerFinished()

virtual void vtkExecutionTimer::TimerFinished | ( |  | ) |
| protectedvirtual

This is where you can do anything you want with the progress event.

By default this does nothing.

## ◆ EventRelay()

static void vtkExecutionTimer::EventRelay | ( | vtkObject * | caller,
|  | unsigned long | eventId,
|  | void * | clientData,
|  | void * | callData
| ) |  |
| staticprotected

This is the callback that VTK will invoke when it sees StartEvent and EndEvent.

Its responsibility is to pass the event on to an instance of this observer class.

## Member Data Documentation

## ◆ Callback

vtkCallbackCommand* vtkExecutionTimer::Callback
| protected

Definition at line 80 of file vtkExecutionTimer.h.

## ◆ Filter

vtkAlgorithm* vtkExecutionTimer::Filter
| protected

Definition at line 83 of file vtkExecutionTimer.h.

## ◆ CPUStartTime

double vtkExecutionTimer::CPUStartTime
| protected

Definition at line 86 of file vtkExecutionTimer.h.

## ◆ CPUEndTime

double vtkExecutionTimer::CPUEndTime
| protected

Definition at line 87 of file vtkExecutionTimer.h.

## ◆ WallClockStartTime

double vtkExecutionTimer::WallClockStartTime
| protected

Definition at line 89 of file vtkExecutionTimer.h.

## ◆ WallClockEndTime

double vtkExecutionTimer::WallClockEndTime
| protected

Definition at line 90 of file vtkExecutionTimer.h.

## ◆ ElapsedCPUTime

double vtkExecutionTimer::ElapsedCPUTime
| protected

Definition at line 92 of file vtkExecutionTimer.h.

## ◆ ElapsedWallClockTime

double vtkExecutionTimer::ElapsedWallClockTime
| protected

Definition at line 93 of file vtkExecutionTimer.h.

The documentation for this class was generated from the following file:

- Filters/Core/vtkExecutionTimer.h